// SD{[iXvZ悤
//
#include <stdio.h>
#include <math.h>

/* Ot萔 */
#define INFILE "shain.txt"	// ̓t@C
#define OUTFILE "bonus.txt"	// o̓t@C
#define ERR_VALUE -1	// G[l
#define CNT 10	// l
#define YEAR 4	// ΑNO[v
#define VAL 4	// NO[v

/* \̂̌^ */
struct person {
    char	name[20];	// O
    float	y;	// ΑN
    char	a[5];	// ]
};

struct money {
    int	base;	// {
    int	point;	// {[iX|Cg
};

/* Oϐ */
struct money dat[YEAR];	// {E{[iX|Cg
float	rank[VAL];	// N
float	rate;	// |

/* ֐̃vg^Cv錾 */
void init(void);
int read_file(struct person man[], int n);
int calc_bonus(struct person man[], int bonus[], int n);
int chk_y(float y);
int chk_a(char *a);
int write_file(struct person man[], int bonus[], int n);

/*
 * main֐
 */
int main(void)
{
    /* ϐ̐錾 */
    struct person man[CNT];	// ǂݍ񂾃f[^
    int	bonus[CNT];	// {[iX
    int	ret;	// ߂l

    /*  */
    init();

    /* t@Cf[^ǂݍ */
    ret = read_file(man, CNT);
    if ( ret < 0 ) {
        return ERR_VALUE;
    }

    /* {[iXvZ */
    ret = calc_bonus(man, bonus, CNT);
    if ( ret < 0 ) {
        return ERR_VALUE;
    }

    /* t@CɃf[^o͂ */
    ret = write_file(man, bonus, CNT);
    if ( ret < 0 ) {
        return ERR_VALUE;
    }

    /* I */
    printf("I܂\n");
    return 0;
}

/*
 * init֐ 
 *    ߂lFȂ
 *      FȂ
 */
void init(void)
{
    /* {E{[iX|Cg */
    dat[0].base = 80000;	dat[0].point = 10000;
    dat[1].base = 100000;	dat[1].point = 12000;
    dat[2].base = 120000;	dat[2].point = 15000;
    dat[3].base = 150000;	dat[3].point = 18000;

    /* N */
    rank[0] = 3.0;
    rank[1] = 2.5;
    rank[2] = 2.0;
    rank[3] = 1.0;

    /* | */
    rate = 2.3;

    return;
}

/*
 * read_file֐
 *    ߂lF펞  0FG[  ERR_VALUE
 *      Fstruct person man[]  ǂݍ񂾃f[^
 *            int n  vf
 */
int read_file(struct person man[], int n)
{
    /* ϐ̐錾 */
    FILE	*fp;	// t@C|C^
    int	i;	// JE^

    /* t@CJ */
    fp = fopen(INFILE, "r");
    if ( fp == NULL ){
        printf("̓t@CJƂł܂ł\n");
        return ERR_VALUE;
    }

    /* f[^ǂݍ */
    i = 0;
    while ( fscanf(fp, "%s%f%s", 
                    man[i].name, &man[i].y, man[i].a) != EOF ) {
        i = i + 1;
    }

    /* t@C */
    fclose(fp);
    return 0;
}

/*
 * calc_bonus֐
 *    ߂lF펞  0FG[  ERR_VALUE
 *      Fstruct person man[]  ǂݍ񂾃f[^
 *            int  bonus  {[iX
 *            int  n      vf
 */
int calc_bonus(struct person man[], int bonus[], int n)
{
    /* ϐ̐錾 */
    int	i;	// JE^
    int	y;	// ΑÑCfbNX
    int	base;	// {
    int	point;	// {[iX|Cg
    int	a;	// ]̃CfbNX
    float	ability;	// |
    float	temp;	// ̎xz

    /* {[iXvZ */
    for (i = 0; i < n; i++) {
        /* ΑÑ`FbN */
        y = chk_y(man[i].y);
        if ( y < 0 ) {
            printf("ΑN܂\n");
            return ERR_VALUE;
        }
        else {
            base = dat[y].base;	// {
            point = dat[y].point;	// {[iX|Cg
        }

        /* ]̃`FbN */
        a = chk_a(man[i].a);
        if ( a < 0 ) {
            printf("]܂\n");
            return ERR_VALUE;
        }
        else {
            ability = rank[a];	// |
        }

        /* xžvZ */
        temp = (base * rate) + (base * ability) + point;
        bonus[i] = ceil(temp);
    }
    return 0;
}

/*
 * chk_y֐
 *    ߂lF펞  CfbNXFG[  ERR_VALUE
 *      Ffloat y  ΑN
 */
int chk_y(float y)
{
    if ( (y >= 0.0) && (y <= 5.12) ){	// `5N12
        return 0;
    }
    else if ( (y >= 6.0) && (y <= 10.12) ){	// 6N0`10N12
        return 1;
    }
    else if ( (y >= 11) && (y <= 15.12) ){	// 11N0`15N12
        return 2;
    }
    else if ( y >= 16 ){	// 16N`
        return 3;
    }
    else {
        return ERR_VALUE;
    }
}

/*
 * chk_a֐
 *    ߂lF펞  CfbNXFG[  ERR_VALUE
 *      Fchar  *a  ]
 */
int chk_a(char *a)
{
    switch (*a) {
        case 'a':
        case 'A':
            return 0;

        case 'b':
        case 'B':
            return 1;

        case 'c':
        case 'C':
            return 2;

        case 'd':
        case 'D':
            return 3;

        default:
            return ERR_VALUE;
    }
}

/*
 * write_file֐
 *    ߂lF펞  0FG[  ERR_VALUE
 *      Fstruct person man[]  ǂݍ񂾃f[^
 *           int  bonus[]  {[iX
 *           int  n        vf
 */
int write_file(struct person man[], int bonus[], int n)
{
    /* ϐ̐錾 */
    FILE	*fp;	// t@C|C^
    int	i;	// JE^

    /* t@CJ */
    fp = fopen(OUTFILE, "w");
    if ( fp == NULL ) {
        printf("o̓t@CJƂł܂ł\n");
        return ERR_VALUE;
    }

    /* t@Cɏo */
    for ( i = 0; i < n; i++ ){
        fprintf(fp, "%s\t%d\n", man[i].name, bonus[i]);
    }

    /* t@C */
    fclose(fp);
    return 0;
}
